package callserver;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

public class ClientEventProvider implements EventProvider {
	/**
	 * @unimod.event.descr 
	 */
	public static final String E21 = "e21";
	/**
	 * @unimod.event.descr  
	 */
	public static final String E22 = "e22";
	/**
	 * @unimod.event.descr   
	 */
	public static final String E23 = "e23";

	
	public static ModelEngine engine;
	/**
	 * @unimod.event.descr  
	 */
	public static final String E24 = "e24";
	
	public static void notify(String event){
		engine.getEventManager().handle(new Event(event), StateMachineContextImpl.create());
	}
	
	public void init(ModelEngine engine) throws CommonException {
		ClientEventProvider.engine = engine;
	
		
	}

	public void dispose() {
	}

}
