package server;

import java.io.*;
import java.rmi.RemoteException;
import server.Bank;

public class BankImpl implements Bank{
//	private final String fileName = BankImpl.class.getResource("Bank.dat").getFile();
	int dataSize;
	int[][] data;
	
	BankImpl(){
		try{
			loadFromFile();
		}catch(Exception e){
			System.out.println("-------------");
			e.printStackTrace();
			System.out.println("-------------");
		}//todo
	}
	
	public void loadFromFile()throws RemoteException{
		try{
			BufferedReader f = new BufferedReader(new InputStreamReader(new FileInputStream("Bank.dat"), "windows-1251"));
			dataSize = Integer.parseInt(f.readLine());
			data = new int[dataSize][3];
			for(int i = 0; i < dataSize; i++){
				data[i][0] = Integer.parseInt(f.readLine());
				data[i][1] = Integer.parseInt(f.readLine());
				data[i][2] = Integer.parseInt(f.readLine());
			}
			f.close();
		}catch(Exception e){
			System.out.println("* - - = Base load error = - - *");
		}
	}

	public void saveToFile()throws RemoteException{
		try{
			BufferedWriter f = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("Bank.dat"), "windows-1251"));
			f.write("" + dataSize + '\n');
			for(int i = 0; i < dataSize; i++){
				f.write("" + data[i][0] + '\n');
				f.write("" + data[i][1] + '\n');
				f.write("" + data[i][2] + '\n');
			}
			f.close();
		}catch(Exception e){
			System.out.println("* - - = Base save error = - - *");
		}
	}

	public boolean checkCard(int N, int pin)throws RemoteException{
		System.out.println("N: '" + N + "'");
		System.out.println("pin: '" + pin + "'");
		boolean found = false;
		for(int i = 0; i < dataSize; i++)
			if((data[i][0] == N) && (data[i][1] == pin)){
				found = true;
				break;
			}
		return found;
	}

	public int getBalance(int N, int pin)throws RemoteException{
		int balance = -1;

		for(int i = 0; i < dataSize; i++)
			if((data[i][0] == N) && (data[i][1] == pin)){
				balance = data[i][2];
				break;
			}
		return balance;
	}

	public boolean getMoney(int N, int pin, int summ)throws RemoteException{
		boolean res = false;
		for(int i = 0; i < dataSize; i++)
			if((data[i][0] == N) && (data[i][1] == pin)){
				System.out.println(i);
				System.out.println("data: " + data[i][2] + " summ: " + summ);
				if(data[i][2] >= summ){
					res = true;
					data[i][2] -= summ;
					saveToFile();
				}
				break;
			}
		System.out.println(res);
		return res;
	}
}

