package client;


import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

public class HardwareEventProvider implements EventProvider {
	/**
	 * @unimod.event.descr  
	 */
	public static final String E6 = "e6";
	/**
	 * @unimod.event.descr  
	 */
	public static final String E7 = "e7";
	/**
	 * @unimod.event.descr  
	 */
	public static final String E8 = "e8";
	/**
	 * @unimod.event.descr  
	 */
	
	public static final String E9 = "e9";
	public static ModelEngine engine;

	public void init(ModelEngine engine) throws CommonException {
		HardwareEventProvider.engine = engine;
		FormPainter.init(engine);
		
        FormPainter.form.notify("");
	}

	public void dispose() {

	}
	
	public static void setTimeout(final String event, int time_delay){
		java.util.Timer t = new java.util.Timer(false);
		t.schedule(
			new java.util.TimerTask() {
				public void run() {
					engine.getEventManager().handle(new Event(event), StateMachineContextImpl.create());
				}
			}, 
			time_delay
		);
	}
}
